// C Source File
// Created 6/11/2001; 2:42:13 PM

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File

//this function simply returns an ASCII character from an ASCII code
//it is needed for the NumIn Function
char Chr(int Rc)
{
	return Rc;
} 
//This function exepts number input from a prompt.
//unlike the gets function this suports Backspace
int NumIn(int ix,int iy)
//ix and iy are the coordinates on the screen where the information 
//recieved is printed as you type it
{
 int count=0,inc;
//count keeps track of which element in the input array is next to be used  
//inc receives the return value from ngetchx which is an ASCII code
 char ful[10];	
//ful is the character array that recieves the keyboard input
	LK:
	inc=ngetchx();
	//here inc receives a character from the keyboard through ngetchx()
	if (inc==KEY_ESC) 
	//checks if escape key was pressed
	{
	exit(0);
	//exits the program with no error
	return(0);
	//the return here servers no purpose but i included it for consistentcy
	}
	
	if (isdigit(inc)) 
	//checks if the key pressed is a number key
	 if (count !=10) 
	 //checks to make sure the user does not type in more than 10 characters 
	  {
		 ful[count]=Chr(inc);
	   //converts the recieved ASCII code into a character with Chr then inserts
	   //the character into the next available element in the array ful
	   count++;
	   //adds one to count so the next time we recieve a character it puts it 
	   //in the next element of ful
	   ful[count]='\0';
		 //terminates the string so extra data is not printed out when we put it 
		 //on the screen
		 printf_xy(ix,iy,"%s",ful);
     //prints the input string onto the screen at the coordinates specified 
     //when	the function is called  
	  }
  if (inc==KEY_ENTER) return(atoi(ful));
  //checks if the user has pressed ENTER if so it returns our input string 
  //in integer form
  if (inc==KEY_BACKSPACE)
  	//checks if the user has pressed BACKSPACE
  if (count != 0)
    //makes sure the user doesnt try to delete characters before the first 
    //one in the array
  	{
  		count--;
  		//subtracts one from count. this sets us back one position in our 
  		//input array
  		ful[count]='\0';
  		//inserts a string termination character into the current space 
  		printf_xy(ix,iy,"          ");
  		//prints out 10 blank spaces, this erases what ever we had typed before 
  		//off the screen
  		printf_xy(ix,iy,"%s",ful);
  	  //prints our newly revised string back where it goes.
  	}
  goto LK;
  //loops back to the label LK where the whole function starts
}

void DrawBox(void)
//im not going to explain every line of this function. it simply draws a line 
//around the border of the screen one pixel from the edge
{
	DrawLine(1,1,LCD_WIDTH-1,1,A_NORMAL);
	DrawLine(LCD_WIDTH-1,1,LCD_WIDTH-1,LCD_HEIGHT-1,A_NORMAL);
	DrawLine(1,LCD_HEIGHT-1,LCD_WIDTH-1,LCD_HEIGHT-1,A_NORMAL);
	DrawLine(1,1,1,LCD_HEIGHT-1,A_NORMAL);
}
// Main Function

void _main(void)
{
	int X1,Y1,Z1;
	//X,Y, and Z coordinates for the first point
	int X2,Y2,Z2;
	//X,Y, and Z coordinates for the second point
	float FullSqr;
	//Recieves the result of the first part of the formula calculated later on in 
	//the program 
	clrscr();
	//clears screen
	DrawBox();
	//calls the custom function we defined earlier 
	FontSetSys(F_8x10);
	//sets the font to 8x10 (The Big Font) 
	printf_xy(35,30,"3D Distance"); 
	printf_xy(38,46,"Calculator");
	ngetchx();
	//prints out the name of the program and waits for a keypress
	clrscr();
	//What do you think this does?
	DrawBox();
	//You know what this is for
	FontSetSys(F_6x8);
	//sets the font back to 6x8, the normal font
	printf_xy(5,5,"Enter coordinates for"); 
	printf_xy(5,15,"first point"); 
	//prints out instructions
	printf_xy(5,25,"X:"); 
	X1=NumIn(20,25);
	//prints out X, calls NumIn at the coordinates 20,25, and puts 
	//the result into X1.
	printf_xy(5,35,"Y:");
	Y1=NumIn(20,35);
	//same as above
	printf_xy(5,45,"Z:");
	Z1=NumIn(20,45);
	//same as above
	
	clrscr();
	DrawBox();
	printf_xy(5,5,"Enter coordinates for"); 
	printf_xy(5,15,"second point"); 
	printf_xy(5,25,"X:");
	X2=NumIn(20,25);
	printf_xy(5,35,"Y:");
	Y2=NumIn(20,35);
	printf_xy(5,45,"Z:");
	Z2=NumIn(20,45);
	//same as the above block but recieves values for the second point
	
	FullSqr=((X2-X1)*(X2-X1))+((Y2-Y1)*(Y2-Y1))+((Z2-Z1)*(Z2-Z1));
	//this looks a bit confusing but it asigns to FullSqr the value of the
	//formula (X2-X1)^2 + (Y2-Y1)^2 + (Z2-Z1)^2 
	FullSqr=sqrt(FullSqr);
	//completes the formula by assinging FullSqr the square root of itself
	clrscr();
	DrawBox();
	//clear screen, draw box
	printf_xy(5,5,"Distance = %f",FullSqr);
	//prints "Distance =" then the result of the formula
	ngetchx();
  //waits for a keypress the exits
}
